import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    private Counter health; 
    private Counter score;
    private Counter timer;
    private Counter timer2;
    int frames = 0;
    private Pacman jack;
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(950, 700, 1); 
        jack = new Pacman();
        addObject (jack, 480, 600);
        addObject (new Ghost(),400, 500);
        addObject (new Ghost2(),450, 500);
        addObject (new Ghost3(),500, 500);
        addObject (new Ghost4(), 550, 500);
        timer2 = new Counter("Secret: ");
        addObject(timer2, 100, 500);
        createWalls();
        health = new Counter("lives:");
        addObject(health, 80,300);
        health.setValue(3);
        score = new Counter("score: ");
        addObject(score, 475, 270);
        score.setValue(0);
        timer = new Counter("timer: ");
        addObject (timer,880, 300); 
        timer.setValue(60);
        timer2.setValue(60);

        createPellets();
        addObject (new Cherries(), 746, 201);
    }

    public void act()
    {  
        frames++;
        if (frames ==60)
        { 
            timer.add(-1);
            timer2.add(-1);
            frames = 0; 
        }
        if (score.getValue() >= 225) 
        {
            Label label = new Label("You Win!", 100);
            label.setFillColor(Color.WHITE);
            addObject(label, 450, 350);

            Greenfoot.stop();
        }
        if (timer.getValue() <= 0) 
        {
            Label label = new Label("You Lose!", 100);
            label.setFillColor(Color.WHITE);
            addObject(label, 450, 350);

            Greenfoot.stop();
        }

        int i = Greenfoot.getRandomNumber(600);
        if(i == 0)
        {
            addObject(new Ghost2(), Greenfoot.getRandomNumber(getWidth()),  Greenfoot.getRandomNumber(700));
        }
    }

    public void addHealth(int value)
    {
        health.add(value);
    } 

    public int getHealth() 
    { return health.getValue();
    }

    public void addScore(int value)
    { score.add(value);
    } 

    public int getScore() 
    { return score.getValue();
    }

    public void addTimer(int value)
    {
        timer.add(value);
    }

    public int getTime()
    {
        return timer2.getValue();
    }

    public void createPellets()
    {
        int x = 0;
        for(int i = 0; i<30; i++)
        {
            x += 30;
            addObject(new Pellet(), 10 + x, 670);
        }
        int y = 0;
        for(int i = 0; i<19; i++)
        {
            y += 30;
            addObject(new Pellet(), 750, 12 + y);
            addObject(new Pellet(), 200, 12 + y);
        }
        x = 0;
        for(int i = 0; i<30; i++)
        {
            x += 30;
            addObject(new Pellet(), 6 + x, 210);
        }
        x = 0;
        for(int i = 0; i<12; i++)
        {
            x += 30;
            if(i!= 5)
            {
                addObject(new Pellet(), 15 + x, 43);
            }
        }
        x = 0;
        for(int i = 0; i<16; i++)
        {
            x += 30;
            if (i!= 0)
            {
                addObject(new Pellet(), 420 + x, 43);
            }
        }
        y = 0;
        for(int i = 0; i<5; i++)
        {
            y += 30;
            addObject(new Pellet(), 40, 38 + y);
            addObject(new Pellet(), 905, 38 + y);
            addObject(new Pellet(), 585, 38 + y);
            addObject(new Pellet(), 480, 38 + y);
            addObject(new Pellet(), 375, 38 + y);
            addObject(new Pellet(), 300, 400 + y);
            addObject(new Pellet(), 660, 400 + y);
        }
        addObject(new Pellet(), 35, 638);
        addObject(new Pellet(), 910, 638);
        x = 0;
        for(int i = 0; i<30; i++)
        {
            x += 30;
            if (i!= 14 && i!= 15 && i!= 22 && i!= 7)
            {
                addObject(new Pellet(), 6 + x, 600);
            }
        }
        x = 0;
        for(int i = 0; i<30; i++)
        {
            x += 30;
            if (i!= 5 && i!= 6 && i!= 24 && i!= 22 && i!= 7)
            {
                addObject(new Pellet(), 4 + x, 400);
            }
        }
        x = 0;
        for(int i = 0; i<15; i++)
        {
            x += 30;
            if (i!= 5 && i!= 14)
                addObject(new Pellet(), 245 + x, 325);
        }

        //211

    }

    public void createWalls()
    {
        addObject(new Wall(10, 500), 10, 0);
        addObject(new Wall(975, 10),450, 0);
        addObject(new Wall(30, 350),425, 0);
        addObject(new Wall(75, 100),130, 130);
        addObject(new Wall(75, 100),300, 130);
        addObject(new Wall(75, 100),665, 130);
        addObject(new Wall(75, 100),825, 130);
        addObject(new Wall(30, 100),525, 130);
        addObject(new Wall(10, 500),950, 0);
        addObject(new Wall(170, 115),75, 300);
        addObject(new Wall(170, 115),75, 500);
        addObject(new Wall(170, 115),890, 300);
        addObject(new Wall(170, 115),890, 500);
        addObject(new Wall(10, 500),0, 600);
        addObject(new Wall(10, 500),950, 600);
        addObject(new Wall(1500, 10),200, 700);
        addObject(new Wall(10, 110),705, 570);
        addObject(new Wall(10, 110),260, 570);
        addObject(new Wall(275, 15),735, 630);
        addObject(new Wall(275, 15),225, 630);
        addObject(new Wall(250, 50),480, 270);
        //addObject(new Wall(275, 20),735, 630);
        addObject(new Wall(10, 170),255, 340);
        addObject(new Wall(10, 170),700, 340);
        addObject(new Wall(190, 10),600, 360);
        addObject(new Wall(80, 10),290, 360);
        addObject(new Wall(20, 70),425, 330);
        addObject(new Wall(300, 15),480, 555);
        addObject(new Wall(20, 125),340, 500);
        addObject(new Wall(20, 125),620, 500);
        addObject(new Wall(60, 20),360, 435);
        addObject(new Wall(60, 20),600, 440);
    }
}